searchNodes=[{"doc":"Create a self-signed certificate. $ mix orbit.gen.cert [hostname] The hostname is optional and defaults to &quot;localhost&quot;. The following files will be created: priv/tls/&lt;hostname&gt;.pem - the certificate priv/tls/&lt;hostname&gt;-key.pem - the private key","ref":"Mix.Tasks.Orbit.Gen.Cert.html","title":"Mix.Tasks.Orbit.Gen.Cert","type":"task"},{"doc":"Initialize an Orbit capsule. $ mix orbit.init NAME The NAME argument is the CamelCase or underscore_case namespace under which the files will be generated, e.g. &quot;my_app_gem&quot; or &quot;MyAppGem&quot;.","ref":"Mix.Tasks.Orbit.Init.html","title":"Mix.Tasks.Orbit.Init","type":"task"},{"doc":"Run the Orbit server. $ mix orbit.server","ref":"Mix.Tasks.Orbit.Server.html","title":"Mix.Tasks.Orbit.Server","type":"task"},{"doc":"A simple Gemini app framework. Quick Start Create a new application: $ mix new my_app --sup Add the dependency: # mix.exs def deps do [ { :orbit , &quot;~&gt; 0.2.0&quot; } ] end Generate some files: $ mix deps.get $ mix orbit.init my_app_gem Generate a self-signed certificate for localhost: $ mix orbit.gen.cert Finally, start the application and visit gemini://localhost/ !","ref":"Orbit.html","title":"Orbit","type":"module"},{"doc":"The main endpoint supervisor. Options Required :endpoint - the Orbit.Pipe entry point that gets called on every request, typically an Orbit.Router One of: :certfile - path to a TLS certificatefile in the PEM format :cert - a DER-encoded certificate binary :cert_pem - a PEM-encoded certificate binary One of: :keyfile - path to a TLS private key file in the PEM format :key - a DER-encoded private key binary :key_pem - a PEM-encoded private key binary Optional :ip - the IP to listen on; could be :any , :loopback , or an address string; defaults to :any :port - the port to listen on; defaults to 1965 Example Child Specification { Orbit.Capsule , endpoint : MyApp.GemRouter , certfile : Path . join ( Application . app_dir ( :my_app , &quot;priv&quot; ) , &quot;cert.pem&quot; ] , keyfile : Path . join ( Application . app_dir ( :my_app , &quot;priv&quot; ) , &quot;key.pem&quot; ) }","ref":"Orbit.Capsule.html","title":"Orbit.Capsule","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Orbit.Capsule.html#child_spec/1","title":"Orbit.Capsule.child_spec/1","type":"function"},{"doc":"Returns metadata about the capsule's TLS listener.","ref":"Orbit.Capsule.html#listener_info/1","title":"Orbit.Capsule.listener_info/1","type":"function"},{"doc":"","ref":"Orbit.Capsule.html#start_link/1","title":"Orbit.Capsule.start_link/1","type":"function"},{"doc":"Commonly-used fields from the TLS client certificate. The original :OTPCertificate record is available in the otp_certificate field. The X509 library is included and can be used to extract additional values from the otp_certificate . Fields common_name - the common name (CN) string fingerprints - a map of base-16 fingerprints for various hashes :sha for SHA-1 :sha256 for SHA-256 not_valid_after - the UTC DateTime at the end of validity not_valid_before - the UTC DateTime at the beginning of validity otp_certificate - the underlying :OTPCertificate record self_signed? - if the certificate has been self-signed (issuer is the same as the subject) serial_number - the serial number integer","ref":"Orbit.ClientCertificate.html","title":"Orbit.ClientCertificate","type":"module"},{"doc":"Returns a new %ClientCertificate{} from a DER-encoded binary.","ref":"Orbit.ClientCertificate.html#from_der/1","title":"Orbit.ClientCertificate.from_der/1","type":"function"},{"doc":"","ref":"Orbit.ClientCertificate.html#t:t/0","title":"Orbit.ClientCertificate.t/0","type":"type"},{"doc":"Utilities for rendering Gemtext.","ref":"Orbit.Gemtext.html","title":"Orbit.Gemtext","type":"module"},{"doc":"Returns the default MIME type for Gemtext content.","ref":"Orbit.Gemtext.html#mime_type/0","title":"Orbit.Gemtext.mime_type/0","type":"function"},{"doc":"Sigil for defining Gemtext content. The assigns map must be in-scope. A single trailing newline character will be trimmed, if it exists. Example def hello ( assigns ) do ~G&quot;&quot;&quot; Why hello there, &lt;%= @name %&gt;! &quot;&quot;&quot; end","ref":"Orbit.Gemtext.html#sigil_G/2","title":"Orbit.Gemtext.sigil_G/2","type":"macro"},{"doc":"The interface for request middleware. Pipes are analogous to the behaviour of Plug . Requests enter the Orbit.Capsule and are passed through a series of pipes that sequentially process the request, and at the end of the pipeline the response is sent to the client. A pipe may also be simple 2-arity anonymous function that implements the same typespec as call/2 . When you use Orbit.Router or use Orbit.Controller , the call/2 callback is injected into the module, turning it into a Pipe.","ref":"Orbit.Pipe.html","title":"Orbit.Pipe","type":"behaviour"},{"doc":"Handle a request. Takes in a a Request, potentially modifies it, and returns a Request. The arg can be any value and is Pipe-dependenent.","ref":"Orbit.Pipe.html#c:call/2","title":"Orbit.Pipe.call/2","type":"callback"},{"doc":"Encapsulate the request-response cycle. Analogous to %Plug.Conn{} . Request Fields client_cert - an Orbit.ClientCertificate for the client TLS certificate, if provided params - combined request parameters from the URI and query params uri - the parsed request URI struct Response Fields body - the response body; may be an iolist or a stream halted? - if the current response pipeline should be stopped prematurely meta - the response meta field, meaning depends on the status code status - the response status code, may be an integer or an atom (see below) sent? - if the response has been transmitted back to the client Application Fields assigns - a generic map of application-defined data to be manipulated and rendered private - a generic map of library-defined data that should not be accessed by end-users","ref":"Orbit.Request.html","title":"Orbit.Request","type":"module"},{"doc":"Sets multiple assigns on the request.","ref":"Orbit.Request.html#assign/2","title":"Orbit.Request.assign/2","type":"function"},{"doc":"Sets a single assign on the request.","ref":"Orbit.Request.html#assign/3","title":"Orbit.Request.assign/3","type":"function"},{"doc":"Stops the request pipeline from further execution.","ref":"Orbit.Request.html#halt/1","title":"Orbit.Request.halt/1","type":"function"},{"doc":"Puts the body and MIME type for a successful response. The MIME type is optional. If unspecified, clients will default to &quot;text/gemini; charset=utf-8&quot;.","ref":"Orbit.Request.html#put_body/3","title":"Orbit.Request.put_body/3","type":"function"},{"doc":"Sets a single private value on the request.","ref":"Orbit.Request.html#put_private/3","title":"Orbit.Request.put_private/3","type":"function"},{"doc":"Puts the status and metadata for a response. If the status code is non-successful, then the response body will be ignored and not sent to the client. The status can be an integer or an atom. See Orbit.Status for a list of applicable status codes and convenience functions.","ref":"Orbit.Request.html#put_status/3","title":"Orbit.Request.put_status/3","type":"function"},{"doc":"Respond with a success status containing body content.","ref":"Orbit.Request.html#success/3","title":"Orbit.Request.success/3","type":"function"},{"doc":"","ref":"Orbit.Request.html#t:t/0","title":"Orbit.Request.t/0","type":"type"},{"doc":"The canonical list of response status codes. This module contains helper functions for applying any status code to an Orbit.Request . When set manually, status codes may be specified by integer or atom. They can be coerced one way or the other with to_atom/1 and to_integer/1 . Status Name 10 :input 11 :sensitive_input 20 :success 30 :redirect_temporary 31 :redirect_permanent 40 :temporary_failure 41 :server_unavailable 42 :cgi_error 43 :proxy_error 44 :slow_down 50 :permanent_failure 51 :not_found 52 :gone 53 :proxy_request_refused 59 :bad_request 60 :client_certificate_required 61 :certificate_not_authorized 62 :certificate_not_valid","ref":"Orbit.Status.html","title":"Orbit.Status","type":"module"},{"doc":"Normalizes a status code to an atom.","ref":"Orbit.Status.html#to_atom/1","title":"Orbit.Status.to_atom/1","type":"function"},{"doc":"Normalizes a status code to an integer.","ref":"Orbit.Status.html#to_integer/1","title":"Orbit.Status.to_integer/1","type":"function"},{"doc":"","ref":"Orbit.Status.html#t:t/0","title":"Orbit.Status.t/0","type":"type"},{"doc":"Process requests and render responses. Options None. Usage The use Orbit.Controller macro injects the following functions into the module: def call ( request , arg ) def action ( request , action ) # overridable The call/2 function implements the Orbit.Pipe callback, making the controller behave like any other pipe. The arg is the action name, as an atom, and is set to the :action assign. Any pipe/2 definitions in this controller are called first, and then action/2 is called. Overriding action/2 The action/2 function is overridable. It's an easy way to extend the controller's default behavior, or to customize the signature of the action functions to something other than action_name(req, params) . Its default implementation is: def action ( req , action ) do apply ( __MODULE__ , action , [ req , req . params ] ) end Views A controller can render responses directly in the controller action, or defer the rendering to an external view module. Define the view/1 pipe to set the view based on the controller action name. view MyApp.MyView def index ( req , _params ) do render ( req ) # =&gt; MyApp.MyView.index(req.assigns) end Layouts Layouts are simply views that are provided an @inner_content assign which contains the content of the child view to render within the layout. Layouts can be nested by pushing additional layouts to the Request. def outer_layout ( assigns ) do ~G&quot;&quot;&quot; begin outer &lt;%= @inner_content %&gt; end outer &quot;&quot;&quot; end def inner_layout ( assigns ) do ~G&quot;&quot;&quot; begin inner &lt;%= @inner_content %&gt; end inner &quot;&quot;&quot; end req |&gt; push_layout ( &amp; outer_layout / 1 ) |&gt; push_layout ( &amp; inner_layout / 1 ) |&gt; render ( ) # =&gt; &quot;&quot;&quot; begin outer begin inner ...view... end inner end outer &quot;&quot;&quot; Example # Router route &quot;/users&quot; , MyApp.UserController , :index route &quot;/users/:id&quot; , MyApp.UserController , :show # Controller defmodule MyApp.UserController do use Orbit.Controller view MyApp.UserView def index ( req , _params ) , do : ... def show ( req , %{ &quot;id&quot; =&gt; id } ) , do : ... end","ref":"Orbit.Controller.html","title":"Orbit.Controller","type":"module"},{"doc":"Removes all layout views.","ref":"Orbit.Controller.html#clear_layouts/2","title":"Orbit.Controller.clear_layouts/2","type":"function"},{"doc":"Gets the Gemtext view to be rendered.","ref":"Orbit.Controller.html#get_view/1","title":"Orbit.Controller.get_view/1","type":"function"},{"doc":"Puts Gemtext content as the body of a successful response.","ref":"Orbit.Controller.html#gmi/2","title":"Orbit.Controller.gmi/2","type":"function"},{"doc":"Returns a list of all layouts.","ref":"Orbit.Controller.html#layouts/1","title":"Orbit.Controller.layouts/1","type":"function"},{"doc":"Define a pipe to run in the controller prior to the action.","ref":"Orbit.Controller.html#pipe/2","title":"Orbit.Controller.pipe/2","type":"macro"},{"doc":"Removes the innermost layout view.","ref":"Orbit.Controller.html#pop_layout/2","title":"Orbit.Controller.pop_layout/2","type":"function"},{"doc":"Adds a nested layout view. Layouts are rendered outer-to-inner, so the first layout pushed onto the stack will be the outermost layout, and the next layout pushed will be nested inside that, and so on. This is typically used directly in a router as a pipe, e.g. pipe { Orbit.Controller , :push_layout } , { MyApp.LayoutView , :main }","ref":"Orbit.Controller.html#push_layout/2","title":"Orbit.Controller.push_layout/2","type":"function"},{"doc":"Sets the response view based on the controller action name. The view rendered is [view_module].[action]/2 .","ref":"Orbit.Controller.html#put_action_view/2","title":"Orbit.Controller.put_action_view/2","type":"function"},{"doc":"Puts a Gemtext view to be rendered if one has not already been set.","ref":"Orbit.Controller.html#put_new_view/2","title":"Orbit.Controller.put_new_view/2","type":"function"},{"doc":"Puts the Gemtext view to be rendered.","ref":"Orbit.Controller.html#put_view/2","title":"Orbit.Controller.put_view/2","type":"function"},{"doc":"Renders the Gemtext view and layouts as a successful response.","ref":"Orbit.Controller.html#render/1","title":"Orbit.Controller.render/1","type":"function"},{"doc":"Sends a file as a binary stream. Options :mime_type - the MIME type of the file; if unspecified, it is determined from the file extension","ref":"Orbit.Controller.html#send_file/3","title":"Orbit.Controller.send_file/3","type":"function"},{"doc":"Define the view module for rendering controller actions. This is a convenience wrapper that simply wraps Orbit.Controller.put_action_view/2 as a pipe/2 definition.","ref":"Orbit.Controller.html#view/1","title":"Orbit.Controller.view/1","type":"macro"},{"doc":"Sort out incoming requests. Usage use Orbit.Router injects the following into the module: import Orbit.Router def call ( req , arg ) Example defmodule MyApp.Router do use Orbit.Router pipe { Orbit.Controller , :push_layout } , { MyApp.LayoutView , :main } pipe MyApp.SetCurrentUser route &quot;/static/*path&quot; , Orbit.Static , from : &quot;priv/static&quot; group do pipe MyApp.RequireCurrentUser route &quot;/messages&quot; , MyApp.MessageController , :index route &quot;/messages/:id&quot; , MyApp.MessageController , :show end end","ref":"Orbit.Router.html","title":"Orbit.Router","type":"module"},{"doc":"Defines a group of routes with a shared pipeline. Groups have their own pipelines that append any existing pipes from parent groups, or from the router. Groups can be nested. Example pipe SetCurrentUser route &quot;/&quot; , HomeController , :show # ...more routes for all users... group do pipe RequireUser route &quot;/profile&quot; , ProfileController , :show # ...more routes for authenticated users... group do pipe RequireAdminRole route &quot;/admin/users&quot; , UserController , :index # ...more routes for authenticated admin users... end end","ref":"Orbit.Router.html#group/1","title":"Orbit.Router.group/1","type":"macro"},{"doc":"Defines a pipe through which requests are processed. The pipe argument may be either: a module that implements Orbit.Pipe a function capture of a 2-arity function a {module, function} tuple that points to a 2-arity public function in a module If the pipe halts the request, the router does not process any further pipes or route matches. Pipelines (sets of pipes) may be constructed by defining pipes inside group/1 blocks.","ref":"Orbit.Router.html#pipe/2","title":"Orbit.Router.pipe/2","type":"macro"},{"doc":"Defines a route that sends a request to a designated pipe. Path segments can contain parameters which are merged into the params field of the request. A wildcard parameter can exist at the very end of a path match. route &quot;/users/:id/edit&quot; , UserController , :edit # =&gt; %{&quot;id&quot; =&gt; &quot;123&quot;} route &quot;/posts/*slug&quot; , PostController , :show # =&gt; %{&quot;slug&quot; =&gt; &quot;favorite/cat/pictures&quot;} The pipe argument may be either: a module that implements Orbit.Pipe a function capture of a 2-arity function a {module, function} tuple that points to a 2-arity public function in a module If no route matches the request path, the router responds with a :not_found status.","ref":"Orbit.Router.html#route/3","title":"Orbit.Router.route/3","type":"macro"},{"doc":"Render Gemtext content. A &quot;view&quot; is any 1-arity function that accepts a map of assigns and returns a string of rendered Gemtext. The ~G sigil is used to precompile EEx templates as strings when an assigns variable or argument is in scope. Views can be defined as functions, or embedded from .gmi.eex files into view module via embed_templates/1 . Usage Add these imports to the view module: import Orbit.Gemtext , only : [ sigil_G : 2 ] import Orbit.View Example defmodule MyApp.MyView do use Orbit.View embed_templates &quot;my_view/*&quot; def list ( assigns ) do ~G&quot;&quot;&quot; &lt;%= for item &lt;- @items do %&gt; * &lt;%= item %&gt; &lt;% end %&gt; &quot;&quot;&quot; end end","ref":"Orbit.View.html","title":"Orbit.View","type":"module"},{"doc":"Define view functions from external files. Every file found in the wildcard path is compiled as EEx and injected as a view function into the view module, using the file basename as the function name. For example, index.gmi.eex will be defined as def index(assigns) .","ref":"Orbit.View.html#embed_templates/1","title":"Orbit.View.embed_templates/1","type":"macro"},{"doc":"Renders a view within another view. The assigns and block arguments are optional. If a block is passed, its contents are renderd and set to @inner_content assign of the view. Examples &lt; % = render &amp; my_view / 1 % &gt; &lt; % = render &amp; my_view / 1 , title : @title % &gt; &lt; % = render &amp; my_component / 1 do % &gt; inner content &lt; % end % &gt;","ref":"Orbit.View.html#render/3","title":"Orbit.View.render/3","type":"macro"},{"doc":"Serve static content from the file system. The :path or *path URL parameter must be specified when defining the route, e.g. route &quot;/static/*path&quot; , Orbit.Static , from : &quot;priv/static&quot; Options :from (required) - the directory to serve","ref":"Orbit.Static.html","title":"Orbit.Static","type":"module"},{"doc":"Callback implementation for Orbit.Pipe.call/2 .","ref":"Orbit.Static.html#call/2","title":"Orbit.Static.call/2","type":"function"},{"doc":"Test helpers.","ref":"OrbitTest.html","title":"OrbitTest","type":"module"},{"doc":"Returns the response body as a binary. Returns nil if the status was not a success.","ref":"OrbitTest.html#body/1","title":"OrbitTest.body/1","type":"function"},{"doc":"Returns a new self-signed Orbit.ClientCertificate for testing. Options :days - the number of days of validity; defaults to 1 day","ref":"OrbitTest.html#build_client_cert/2","title":"OrbitTest.build_client_cert/2","type":"function"},{"doc":"Returns the response meta field.","ref":"OrbitTest.html#meta/1","title":"OrbitTest.meta/1","type":"function"},{"doc":"Performs a request and returns the processed request. If path_or_url begins with &quot;/&quot; , a path is assumed and the requested URL is &quot;gemini://localhost/&lt;path&gt;&quot; . Options :client_cert - the client certificate, which can be constructed with build_client_cert/2 :query - the URL query string, or key/value pairs as a map or keyword list :router - the router to handle the request; defaults to @router","ref":"OrbitTest.html#request/2","title":"OrbitTest.request/2","type":"macro"},{"doc":"Returns the response status code as an atom.","ref":"OrbitTest.html#status/1","title":"OrbitTest.status/1","type":"function"},{"doc":"A simple framework for a simple protocol. 🚧 🚧 🚧 Alpha software - under active delopment 🚧 🚧 🚧 Orbit borrows a lot of ideas from Plug and Phoenix. The foundation consists of: Orbit.Capsule - TLS endpoint that accepts incoming connections (like Phoenix.Endpoint and cowboy combined) Orbit.Request - encapsulates the request-response lifecyle (like Plug.Conn ) Your application implements: Orbit.Pipe - the behaviour for request middleware (like Plug ) Orbit.Router - defines pipelines and routes Orbit.Controller - processes requests and render views Orbit.View - renders Gemtext content Some additional niceties: Orbit.Static - serves up static content Orbit.Status - applies response status codes","ref":"readme.html","title":"🪐 Orbit - a Gemini app framework for Elixir","type":"extras"},{"doc":"See the GitHub project for the latest progress.","ref":"readme.html#there-s-still-a-lot-todo","title":"🪐 Orbit - a Gemini app framework for Elixir - There's still a lot TODO!","type":"extras"},{"doc":"Orbit can be added to any existing application, including a Phoenix one. See the Quick Start guide for installation instructions.","ref":"readme.html#installation","title":"🪐 Orbit - a Gemini app framework for Elixir - Installation","type":"extras"}]